include "zxsysvar.s"
;
define CONIO_SELF
include "conio.s"
;-------------------------------------------------
;   
; DE -  (Dy Ex), A -  
;-------------------------------------------------
out_char:
	; HL - symbol in font adr
	LD L,A
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD BC,font
        ADD HL,BC
        ; DE - screen adress
        LD A,D
        AND 7
        RRCA
        RRCA
        RRCA
        OR E
        LD E,A
        LD A,D
        AND 24
        OR 64
        LD D,A
        ;   
        PUSH DE
        ;  
        LD B,8
out_char_1:
        LD A,(HL)
        LD (DE),A
        INC HL
        INC D
        djnz out_char_1
        ; 
        POP DE
        ;in: DE - screen adress
	;out:DE - attr adress
        LD A,D
        RRCA
        RRCA
        RRCA
        AND 3
        OR #58
        LD D,A
        ;  
        LD A,(ATTR_T)
        LD (DE),A
        ;
        RET        ;...
;-------------------------------------------------
;  
; HL -  
;-------------------------------------------------
xdef out_str
out_str:
	ld a,(hl)
	or a
	;   0
	ret z
	push hl
	; 
	ld de,(cur_x)
	;    
	; ----------------------------
	; \n	SYM_NL
	cp SYM_NL
	jr z,out_str_nl
	; ----------------------------
	; AT	SYM_AT
	cp SYM_AT
	jr nz, out_str_no_at
	pop hl
	inc hl
	ld e,(hl) ; X
	inc hl
	ld d,(hl) ; Y
	push hl
	jr out_str_cont
out_str_no_at:
	; TAB	SYM_TAB
	cp SYM_TAB
	jr nz, out_str_no_tab
	;  - 8 
	ld a, 2^K_TAB
	add e
	and 255- 2^K_TAB + 1 
	ld e,a
	jr out_str_modify_x
out_str_no_tab:
	;    
	; 
	push de
	call	out_char
	pop de
	; ޣ 
	; X
	inc e
	;      
out_str_modify_x:
	ld a,SCR_TXT_W-1
	cp e
	jr nc,out_str_cont
	;  
out_str_nl:
	ld e,0
	; Y
	inc d
	;      
	ld a,SCR_TXT_H-1
	cp d
	jr nc,out_str_cont
	dec d
	;     
	push	de
	call scroll_up
	pop	de
	;
out_str_cont:
	;  
	ld (cur_x),de
	pop hl
	inc hl
	jr out_str
;-------------------------------------------------
;	 
;-------------------------------------------------
xdef cls
cls:
	; clear
	ld hl,(screen_adr)
	ld de,(screen_adr)
	inc de
	ld bc,0x17FF
	ld (hl),0
	ldir
	; attr
	inc hl
	inc de
	ld a,(ATTR_P)
	ld (ATTR_T),a
	ld (hl),a
	ld bc,0x2FF
	ldir
	;
	xor a
	ld (cur_x),a
	ld (cur_y),a
	;
	ret
;-------------------------------------------------
;   
;-------------------------------------------------
scroll_up:
;	1 st
	LD DE,(screen_adr)
	LD HL,	$0020
	ADD HL,DE
	LD BC,	$07E0
	LDIR
	LD B,	$08
	LD A,	D
	AND	$F8
	LD	D,A	; DE = $40E0 
	PUSH	HL	; HL = $4800 store
L3:
	PUSH BC
	PUSH HL
	PUSH DE
	LD BC,	$0020
	LDIR
	POP DE
	POP HL
	POP BC
	INC D
	INC H
	DJNZ L3
;	2 st
	POP DE	; store HL = $4800 restore DE
	LD HL,	$0020
	ADD HL,DE
	;
	LD BC,	$07E0
	LDIR
	LD B,	$08
	LD A,	D
	AND	$F8
	LD	D,A	; DE = $40E0 
	;
	PUSH	HL	; HL = $5000 store
	
L4:
	PUSH BC
	PUSH HL
	PUSH DE
	LD BC,	$0020
	LDIR
	POP DE
	POP HL
	POP BC
	INC D
	INC H
	DJNZ L4
;	3 st
	POP DE	; store HL = $5000 restore DE
	LD HL,	$0020
	ADD HL,DE
	;
	LD BC,	$07E0
	LDIR
	LD B,	$08
;   
	or a
	LD DE,$0720
	SBC HL,DE
L5:
	PUSH BC
	PUSH HL
	LD B,	$20
L6:
	LD(HL),0
	INC HL
	DJNZ L6
	POP HL
	POP BC
	INC H
	DJNZ L5
;	.

	RET
;-------------------------------------------------
screen_adr: defw	0x4000
;  
cur_x:	defb	0x00
cur_y:	defb	0x00
;-------------------------------------------------
;   ģ
;-------------------------------------------------
font:
	binary "koi8r-8x8.chr"
