;-------------------------------
; Constant of extended keys
;-------------------------------
defc LSHIFT=	$01
defc RSHIFT=	$02

defc LALT=	$03
defc RALT=	$04

defc LCTRL=	$05
defc RCTRL=	$06

defc LWIN=	$07
defc RWIN=	$08

defc INSERT=	$09
defc HOME=	$0A

defc PGUP=	$0B
defc PGDN=	$0C

defc KDELETE=	$0D
defc KEND=	$0E

defc UP=	$0F
defc DN=	$10
defc LEFT=	$11
defc RIGHT=	$12

defc F1=	$13
defc F2=	$14
defc F3=	$15
defc F4=	$16
defc F5=	$17
defc F6=	$18
defc F7=	$19
defc F8=	$1A
defc F9=	$1B
defc F10=	$1C
defc F11=	$1D
defc F12=	$1E

defc NUMLOCK=	$1F
defc KPDIV=	$20
defc KPMUL=	$21
defc KPMIMUS=	$22
defc KPPLUS=	$23
defc KPENTER=	$24
defc KPPOINT=	$25

defc KP0=	$26
defc KP1=	$27
defc KP2=	$28
defc KP3=	$29
defc KP4=	$30
defc KP5=	$31
defc KP6=	$32
defc KP7=	$33
defc KP8=	$34
defc KP9=	$35

defc CAPS=	$36

defc PS2_RUS=	0
defc PS2_ALT=	0

defc PS2_CAPS=	1
defc PS2_SHIFT=	1

defc PS2_CTRL=	2

;-------------------------------
IF !PS2_SELF
	;     PS2
	xref	InitPS2
	;  -  HL
	;  7 L = 1,    E0
	;  8 H = 1,   
	xref	GetPS2
	;   HL    ޣ 
	; H=0, L=KOI8-R
	; H=1, L=  (F1-F12,   .)
	;     
	; Rus/LAT - CTRL+SHIFT
	xref	InKey
ENDIF
;-------------------------------
