	include "ps2.s"
	include "conio.s"
	;
	call cls

	call InitPS2
	;
	ld hl,str_h
	call out_str
	
key_loop:
	call InKey
	;  ?
	ld a,l
	or a
	jr z,key_loop
	;  ?
	bit 0,h
	jr nz, ext_key
	
	;    
	; ESC - exit
	cp 0x1B
	ret z
	;     
	ld de,str
	ld (de),a
	;
	ld hl,str
	call out_str
	jr key_loop
	
ext_key:
	push hl
	ld hl,str_ext
	call out_str
	pop hl
	; 
	ld de,F_tbl
	;
ext_key_l:
	ld a,(de)
	or a
	jr z,key_loop
	; 
	cp l
	jr z, ext_key_f
	inc de
	inc de
	inc de
	jr ext_key_l
	; 
ext_key_f:
	push de
	ld hl,str_extf
	call out_str
	pop hl
	;    
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	push de
	pop hl
	call out_str
	jr key_loop

str_h:
	defm	"- Keytester PS/2 -",0x0A,0
str_ext:
	defm	"-Extkey-",0x0A,0
str_extf:
	defm	"Found: ",0

;    
str:
	defm 0,0x0A,0

F1_S:	defm "F1",0x0A,0
F2_S:	defm "F2",0x0A,0
F3_S:	defm "F3",0x0A,0
F4_S:	defm "F4",0x0A,0
F5_S:	defm "F5",0x0A,0
F6_S:	defm "F6",0x0A,0
F7_S:	defm "F7",0x0A,0
F8_S:	defm "F8",0x0A,0
F9_S:	defm "F9",0x0A,0
F10_S:	defm "F10",0x0A,0
F11_S:	defm "F11",0x0A,0
F12_S:	defm "F12",0x0A,0

F_tbl:
	defb F1
	defw F1_S
	defb F2
	defw F2_S
	defb F3
	defw F3_S
	defb F4
	defw F4_S
	defb F5
	defw F5_S
	defb F6
	defw F6_S
	defb F7
	defw F7_S
	defb F8
	defw F8_S
	defb F9
	defw F9_S
	defb F10
	defw F10_S
	defb F11
	defw F11_S
	defb F12
	defw F12_S
	defb 0
